local eventFrame = CreateFrame("Frame")
local QuickHealth = LibStub("LibQuickHealth-1.0")
local sRaidFrames = sRaidFrames
local _G = getfenv(0);

-- env changement code taken from interruptus
local proxyEnv = {
	UnitHealth = function(...) return QuickHealth.UnitHealth(QuickHealth, ...); end,
}

setmetatable(proxyEnv, { 
	__index    = _G,
	__newindex = function (t, k, v) _G[k] = v end,
})

eventFrame:SetScript("OnEvent", function(self)
	local oldEnv = getfenv(sRaidFrames.UpdateUnitHealth);
	QuickHealth.RegisterCallback(self, "HealthUpdated", function(event, GUID, newHealth)
		setfenv(sRaidFrames.UpdateUnitHealth, proxyEnv);
		for unitid in pairs(sRaidFrames:GetAllUnits()) do
			if(GUID == UnitGUID(unitid)) then
				sRaidFrames:UpdateUnitHealth(unitid)
			end
		end
		setfenv(sRaidFrames.UpdateUnitHealth, oldEnv);
	end);
end);

eventFrame:RegisterEvent("PLAYER_LOGIN");